%*************************************************************************
%
%   ACTIVE CONTOURS
%   per la segmentazione di depth maps
%
%   Ivano Calabrese                  
%   Nicola Carlon
%   Tesina per il corso di Elaborazione delle Immagini e Grafica 3D
%*************************************************************************
%% Tracciare poligoni utilizzando il mouse
clc
close all
clear all
fprintf('\n\n===================================================================\n')
fprintf(' Tesina per il corso di Elaborazione delle Immagini e Grafica 3D\n\n')
fprintf(' + ACTIVE CONTOURS\n')
fprintf('   per la segmentazione di depth maps\n')
fprintf('                             ____________________________________\n')
fprintf('                                  Ivano Calabrese - Nicola Carlon\n')
fprintf('                                                  (o4-Marzo-2o1o)\n')
fprintf('-------------------------------------------------------------------\n')
polyON=1; % abilito la creazione del poligono
xyPoly=[]; % creo la matriche che conterra' le coordinate del poligono
           % le x e y rispettivamente prima e seconda colonna.

%Caricamento dell'immagine
fprintf('Selezionare l''immagine da segmentare...')
[file,path]=uigetfile({'*.jpg*;*.bmp;*.jpeg;*.tiff;*.png;*.gif', 'Pick an Image-File'});
pathfile=strcat(path,file);
I=imread(pathfile);
fprintf('FATTO!\n')
%Eventuale conversione in scala di grigi
[h w c]=size(I);
if(c==3)
    I=rgb2gray(I);
end
I=im2double(I);

%% Parametri
%parametri elasticit, tensione e forze esterne
fprintf('---\n')
fprintf('Setting dei parametri:\n')
alpha = input(' Tensione []=50\% : ');
if(isempty(alpha))
    alpha=50;
end
beta = input(' Rigidit []=50\% : ');
if(isempty(beta))
    beta = 50;
end
delta = input(' Compensazione []=1 : ');
if(isempty(delta))
    delta = 1;
end
resolution = input(' Risoluzione step []=100\% : ');
if(isempty(resolution))
    resolution =100;
end
iterazioni = input(' Numero di iterazioni []=500 : ');
if(isempty(iterazioni))
    iterazioni = 500;
end

soglia=input('Vuoi utilizzare la soglia automatica? []=yes, n=no\n','s');
if(soglia=='n')
    %Visualizzazione dell'immagine
    figure('Name','Inizializzazione soglia')
    imshow(I)
    hold on
    fprintf('\nSeleziona due punti sulla depth map da segmentare cliccando sul punto pi vicino e su quello pi lontano della regione interessata...\n')
    [xmouse,ymouse,button] = ginput(1);
    T1=I(ceil(ymouse),ceil(xmouse));
    [xmouse,ymouse,button] = ginput(1);
    T2=I(ceil(ymouse),ceil(xmouse));
    close all;
else
    T1=-1;
end
fprintf('---\n')

% prendo in input le coordinate del mouse
%   xmouse => coordinata x del mouse 
%   ymouse => coordinata y del mouse
%   button = 1 => tasto SX
%   button = 2 => tasto middle
%   button = 3 => tasto DX

fprintf('Tracciare la curva che inizializza lo Snake\n')
fprintf(' + clic Sx = vincola la curva nel punto di intersezione delle due rette\n')
fprintf(' + clic Dx = termina la l''inizializzazione dello Snake\n')

%Visualizzazione dell'immagine
figure('Name','Inizializzazione snake')
imshow(I)
hold on
fprintf('\nInizializzazione snake...\n')
while polyON==1
    [xmouse,ymouse,button] = ginput(1);
    if(xmouse<1)xmouse=1;end
    if(ymouse<1)ymouse=1;end
    if(xmouse>size(I,2))xmouse=size(I,2)-1;end
    if(ymouse>size(I,1))ymouse=size(I,1)-1;end
   
    plot(xmouse,ymouse,'o','MarkerEdgeColor','g','MarkerFaceColor','g')
    xyPoly=[xyPoly;[xmouse,ymouse]];
    polyON=button;
    if polyON~=1
        xyPoly=[xyPoly;xyPoly(1,:)]; % chiudo il poligono sovrapponendo primo e ultimo punto
    end
    plot(xyPoly(:,1),xyPoly(:,2),'g','LineWidth',2)
    fprintf('.')
end
fprintf('..COMPLETATA!\n')

%Interpolazione contorno user-defined
img = poly2mask(xyPoly(:,1),xyPoly(:,2),size(I,1),size(I,2));
boundary=bwboundaries(img);
if(isempty(boundary))
    fprintf('Interpolazione fallita, uso metodo semplice');
    passo =0.01;
    a = [1:1:size(xyPoly(:,1),1)]'; 
    b = [1:passo:size(xyPoly(:,1),1)]';
    x = interp1(a,xyPoly(:,1),b); 
    y = interp1(a,xyPoly(:,2),b); 
else
    x=boundary{1}(:,2);
    y=boundary{1}(:,1);
end
%% Mimimizzazione
fprintf('Segmentazione in corso...\n')
close all;
figure('Name','Minimizzazione')
imshow(I)
tic;
[xf yf i]=snake(I,x,y,alpha,beta,resolution,delta,iterazioni,T1,T2);

%Creazione ROI
mask = poly2mask(xf,yf,size(I,1),size(I,2));

timer=toc;
fprintf('segmentazione COMPLETATA!\n')
fprintf(' > tempo di elaborazione = %3.1f sec',timer)

%% Visualizzazione dei risultati

ask=input('\nVuoi usare la maschera trovata per segmentare un''immagine diversa dall''originale? y=yes, []=no \n','s');
if(ask=='y')
    [file,path]=uigetfile({'*.jpg*;*.bmp;*.jpeg;*.tiff;*.png;*.gif', 'Pick an Image-File'});
    pathfile=strcat(path,file);
    O=imread(pathfile);
    [h w c]=size(O);
    if(c==3)
        O=im2double(O);
        O(:,:,1)=[O(:,:,1).*mask];
        O(:,:,2)=[O(:,:,2).*mask];
        O(:,:,3)=[O(:,:,3).*mask];
    end
    figure('Name','Risultato')
    imshow(O);
else
    figure('Name','Risultato')
    imshow(I.*mask);
end
title(['Segmentazione dopo ',num2str(i-1),' iterazioni'])
%hold on, patch(xf,yf,'c','EdgeColor','none','FaceAlpha',0.5);

fprintf('\n\n\n')
fprintf('   ------------------------\n\n')
fprintf('    LA DEMO E'' COMPLETATA!\n\n')
fprintf('   ------------------------\n\n')
